math.randomseed(os.time())

--Setup
function love.load()
	
	--Config
	setting={}
	settingNr=1
	for settings in love.filesystem.lines("settings.cfg") do
		if string.sub(settings, 1, 1) == "#" then
			setting[settingNr]=tonumber(string.sub(settings, 2))
			settingNr=settingNr+1
		end
	end
	settingNr=nil
	
	fullscreenSetting=(setting[1]==1)										--Fullscreen Boolean
	if fullscreenSetting then
		length, height = love.window.getDesktopDimensions()
		length=length/10
		height=height/10
		love.window.setMode(length*10,height*10,{fullscreen=true})
	else
		height=setting[2]													--Window Height
		length=setting[3]													--Window Width
		love.window.setMode(length*10,height*10,{})
	end
	
	
	
	--Set Variables
	bodyparts=0		tiles={}
	directionX=0		directionY=0
	go=false			speed=setting[4]
	-------------------------------------
	bodyX={}			bodyY={}
	bodyX[0]=length/2	bodyY[0]=height/2
	--------------------------------------
	starPosX=0		starPosY=0
	events=0			que={}
	newStar=true		star=0
	---------------------------------
	greenStar=false	green=false
	greenStars=(setting[7]==1)
	greenStarX=0		greenStarY=0
	greenTimer=-1		darkGreen=false
	
	
	--Load Resources
	blingSnd=love.audio.newSource("bling.mp3")
	deathSnd=love.audio.newSource("wrong.mp3")
	blueImg=love.graphics.newImage("blue.png")
	greenImg=love.graphics.newImage("green.png")
	local startex = "star.png"
	if setting[6]==1 then startex="blueStar.png" end
	starImg=love.graphics.newImage(startex)
	greenStarImg=love.graphics.newImage("greenStar.png")
	darkGreenImg=love.graphics.newImage("darkGreen.png")
	
	--Make Empty World
	for for1=1,length do
		for for2=1,height do
			tiles[for1]={}
			tiles[for1][for2]=false
		end
	end
	
end


--Event Handler
function getNextEvent()
	if events==0 then return nil else
		nextEvent=que[1]
		for indexCounter=1,events do
			que[indexCounter]=que[indexCounter+1]
		end
		events=events-1
		return nextEvent
	end
end


--Key Events
function love.keypressed( key )
	if key=="down" then
		events=events+1 que[events]=3
	elseif key=="up" then
		events=events+1 que[events]=1
	elseif key=="right" then
		events=events+1 que[events]=2
	elseif key=="left" then
		events=events+1 que[events]=4
	elseif key==" " then
		speed=setting[5]
	end
end


--KeyEvents
function love.keyreleased( key )
	if key==" " then
		speed=setting[4]
	end
end


--Processing
function love.update()
	
  --Delay
  love.timer.sleep(speed)
	
	if not go then
	
	--Green Timer
	if greenTimer==0 then
		green=false
		greenTimer=-1
		darkGreen=false
	elseif greenTimer>0 then
		greenTimer=greenTimer-1
	end
	if greenTimer<40 and greenTimer%2==0 then
		darkGreen=true
	elseif greenTimer<40 and greenTimer%2==1 then
		darkGreen=false
	end
	
	--Make Snake Longer
	if star>0 then
		star=star-1
		bodyparts=bodyparts+1
		bodyX[bodyparts]=0
		bodyY[bodyparts]=0
	end
	
	--Move Snake Body
	for for5=1,bodyparts do
		bodyX[(bodyparts+1)-for5]=bodyX[((bodyparts+1)-for5)-1]
		bodyY[(bodyparts+1)-for5]=bodyY[((bodyparts+1)-for5)-1]
	end
	
	--Handle Events
	::eventstart::
	handlingEvent=getNextEvent()
	if handlingEvent==1 and (directionY==0 or (not (directionY==-1) and bodyparts==0)) then
		directionX=0
		directionY=-1
	elseif handlingEvent==2 and (directionX==0 or (not (directionX==1) and bodyparts==0)) then
		directionX=1
		directionY=0
	elseif handlingEvent==3 and (directionY==0 or (not (directionY==1) and bodyparts==0)) then
		directionX=0
		directionY=1
	elseif handlingEvent==4 and (directionX==0 or (not (directionX==-1) and bodyparts==0)) then
		directionX=-1
		directionY=0
	elseif handlingEvent==nil then else
		goto eventstart
	end
	
	--Move Snake Head
	bodyX[0]=directionX+bodyX[0]
	bodyY[0]=directionY+bodyY[0]

	--Wall Death Check
	if directionX==1 and directionY==0 and bodyX[0]>length then
		go=true
	elseif directionX==-1 and directionY==0 and bodyX[0]<1 then
		go=true
	elseif directionX==0 and directionY==1 and bodyY[0]>height then
		go=true
	elseif directionX==0 and directionY==-1 and bodyY[0]<1 then
		go=true
	end
	if go then love.audio.play(deathSnd) goto endgame end
	
	--Intersecting Death Check
	if not green then
		for checkingToHit=1,bodyparts do
			if bodyY[checkingToHit]==bodyY[0] and bodyX[checkingToHit]==bodyX[0] then
				go=true love.audio.play(deathSnd) goto endgame
			end
		end
	end
	
	--Reset Tiles
	for for15=1,length do
		for for16=1,height do
			tiles[for15][for16]=false
		end
	end
	
	--Write Tiles
	for for6=0,bodyparts do
		tiles[bodyX[for6]][bodyY[for6]]=true
	end
	
	--New Star
	if newStar then
		newStar=false
		while true do
			starPosX=math.random(1,length)
			starPosY=math.random(1,height)
			if not tiles[starPosX][starPosY] then
				break
			end
		end
	end
	if greenStars and bodyparts>8	and (not greenStar) and (math.random(1,1200)==1) then	--10 long
		greenStar=true
		while true do
			greenStarX=math.random(1,length)
			greenStarY=math.random(1,height)
			if not tiles[greenStarX][greenStarY] then
				break
			end
		end
	end
	
	--Collect Star
	if bodyX[0]==starPosX and bodyY[0]==starPosY then
		love.audio.play(blingSnd)
		star=star+1
		newStar=true
	end
	if bodyX[0]==greenStarX and bodyY[0]==greenStarY and greenStar then
		love.audio.play(blingSnd)
		green=true
		greenTimer=160
		greenStar=false
		greenStarX=0
		greenStarY=0
	end
	
  end
  ::endgame::

end



function love.draw()
	
	--Draw Tiles
	for for3=1,length do
		for for4=1,height do
			if tiles[for3][for4] then
				local pic=blueImg
				if green then if darkGreen then pic=darkGreenImg else pic=greenImg end end
				love.graphics.draw(pic, for3*10-10, for4*10-10)
			elseif for3==starPosX and for4==starPosY then
				if not go then love.graphics.draw(starImg, for3*10-10, for4*10-10) end
			elseif for3==greenStarX and for4==greenStarY then
				if not go then love.graphics.draw(greenStarImg, for3*10-10, for4*10-10) end
			end
		end
	end	
end